import { jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import FormatUnderlined from '@sinoui/icons/FormatUnderlined';
import { useDispatch, useSelector } from 'react-redux';
import setCellTextStyleHelper from '../../utils/setCellTextStyleHelper';
import CustomEditor from '../../utils/CustomEditor';
import DenseIconButton from './DenseIconButton';
import useSingleStyleActive from './useSingleStyleState';
/**
 * 下划线
 */
function FormatUnderlinedButton({ editor = {}, selectedRange, editingCell, }) {
    const dispatch = useDispatch();
    const rows = useSelector((state) => state.present.rows);
    const merges = useSelector((state) => state.present.merges);
    const [isActive, setIsActive] = useSingleStyleActive('underLine', selectedRange, CustomEditor.isUnderLineMarkActive);
    const handleMouseDown = (event) => {
        event.preventDefault();
        if (!editingCell) {
            setIsActive(!isActive);
        }
        setCellTextStyleHelper(editor, dispatch, 'underLine', '', rows, merges, selectedRange, editingCell);
    };
    return (_jsx(DenseIconButton, { isActive: isActive, dense: true, onMouseDown: handleMouseDown, children: _jsx(FormatUnderlined, {}) }));
}
export default React.memo(FormatUnderlinedButton);
