import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import IconButton from '@sinoui/core/IconButton';
import Menu, { MenuListItem } from '@sinoui/core/Menu';
import FormatAlignCenter from '@sinoui/icons/FormatAlignCenter';
import FormatAlignLeft from '@sinoui/icons/FormatAlignLeft';
import FormatAlignRight from '@sinoui/icons/FormatAlignRight';
import { useRef, useState } from 'react';
import { useDispatch, useSelector } from 'react-redux';
import { setCellsStyle } from '../../reducer';
import getAllSelectedCells from '../../utils/getAllSelectedCells';
export default function HorizontalSelectButton({ selectedRange, disabled, }) {
    const [value, setValue] = useState('left');
    const [open, setOpen] = useState(false);
    const anchorEl = useRef(null);
    const dispatch = useDispatch();
    const merges = useSelector((state) => state.present.merges);
    const handleClick = (val) => {
        setValue(val);
        setOpen(false);
        if (!selectedRange)
            return;
        const cells = getAllSelectedCells(selectedRange, merges);
        dispatch(setCellsStyle(cells, { horizontal: val }));
    };
    const render = () => {
        if (value === 'right') {
            return _jsx(FormatAlignRight, {});
        }
        if (value === 'center') {
            return _jsx(FormatAlignCenter, {});
        }
        return _jsx(FormatAlignLeft, {});
    };
    return (_jsxs(_Fragment, { children: [_jsx(IconButton, { disabled: disabled, style: { borderRadius: 0 }, dense: true, onClick: () => setOpen(true), ref: anchorEl, children: render() }), _jsxs(Menu, { dense: true, open: open, referenceElement: anchorEl, onRequestClose: () => setOpen(false), children: [_jsx(MenuListItem, { onClick: () => handleClick('left'), children: _jsx(FormatAlignLeft, {}) }), _jsx(MenuListItem, { onClick: () => handleClick('center'), children: _jsx(FormatAlignCenter, {}) }), _jsx(MenuListItem, { onClick: () => handleClick('right'), children: _jsx(FormatAlignRight, {}) })] })] }));
}
