import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import Dialog from '@sinoui/core/Dialog';
import IconButton from '@sinoui/core/IconButton';
import Setting from '@sinoui/icons/Settings';
import { useFormState } from '@sinoui/rx-form-state';
import React, { useRef, useState } from 'react';
import { useDispatch, useSelector } from 'react-redux';
import { ActionType } from '../../reducer';
import PageConfigForm from './PrintConfigPanel';
/**
 * 打印设置按钮
 *
 * @returns
 */
function PrintConfigButton() {
    const anchorEl = useRef(null);
    const dispatch = useDispatch();
    const pageConfig = useSelector((state) => state.present.config);
    const formState = useFormState(pageConfig);
    const [open, setOpen] = useState(false);
    const handleClick = () => {
        setOpen(true);
    };
    const handleOk = () => {
        dispatch({
            type: ActionType.SET_PRINT_CONFIG,
            payload: formState.values,
        });
        setOpen(false);
    };
    const handleClose = () => {
        setOpen(false);
    };
    return (_jsxs(_Fragment, { children: [_jsx(IconButton, { dense: true, ref: anchorEl, style: { borderRadius: 0 }, onMouseDown: handleClick, children: _jsx(Setting, {}) }), _jsx(Dialog, { open: open, children: _jsx(PageConfigForm, { formState: formState, onOk: handleOk, onClose: handleClose }) })] }));
}
export default React.memo(PrintConfigButton);
