import { jsx as _jsx } from "react/jsx-runtime";
import IconButton from '@sinoui/core/IconButton';
import Redo from '@sinoui/icons/Redo';
import { useMemo } from 'react';
import { useDispatch, useSelector } from 'react-redux';
import { ActionCreators } from 'redux-undo';
/**
 * 恢复按钮，与撤销按钮结对使用
 *
 * @returns
 */
export default function RedoButton() {
    const dispatch = useDispatch();
    const future = useSelector((state) => state.future);
    const handleClick = () => {
        dispatch(ActionCreators.redo());
    };
    const disabled = useMemo(() => future.length === 0, [future.length]);
    return (_jsx(IconButton, { style: { borderRadius: 0 }, dense: true, onClick: handleClick, disabled: disabled, children: _jsx(Redo, {}) }));
}
