import { jsx as _jsx } from "react/jsx-runtime";
import IconButton from '@sinoui/core/IconButton';
import Undo from '@sinoui/icons/Undo';
import { useMemo } from 'react';
import { useDispatch, useSelector } from 'react-redux';
import { ActionCreators } from 'redux-undo';
/**
 * 撤销按钮
 *
 * @returns
 */
export default function UndoButton() {
    const dispatch = useDispatch();
    const history = useSelector((state) => state.past);
    const handleClick = () => {
        dispatch(ActionCreators.undo());
    };
    const disabled = useMemo(() => history.length === 0, [history.length]);
    return (_jsx(IconButton, { style: { borderRadius: 0 }, dense: true, onClick: handleClick, disabled: disabled, children: _jsx(Undo, {}) }));
}
