import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import isEqual from 'lodash/isEqual';
import React from 'react';
import styled from 'styled-components';
import { BgColorPickerButton, ColorPickerButton, FontFamilySelectButton, FontSizeSelectButton, FormatBoldButton, FormatDeleteLinedButton, FormatItalicButton, FormatUnderlinedButton, BorderButton, MergeButton, PrintConfigButton, RedoButton, UndoButton, HorizontalSelectButton, VerticalSelectButton, } from '../plugins';
const Layout = styled.div `
  display: flex;
  align-items: center;
  height: 40px;
  border-bottom: 1px solid #e0e2e4;
  background-color: #f5f6f7;
`;
function Toolbar({ editor, selectedRange, editingCell }) {
    return (_jsxs(Layout, { children: ["|", _jsx(UndoButton, {}), _jsx(RedoButton, {}), "|", _jsx(FormatBoldButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), _jsx(FormatItalicButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), _jsx(FormatUnderlinedButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), _jsx(FormatDeleteLinedButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), "|", _jsx(BgColorPickerButton, { selectedRange: selectedRange, disabled: !selectedRange || !!editingCell }), _jsx(ColorPickerButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), "| \u00A0", _jsx(FontFamilySelectButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), "\u00A0", _jsx(FontSizeSelectButton, { editor: editor, selectedRange: selectedRange, editingCell: editingCell }), "\u00A0 |", _jsx(HorizontalSelectButton, { selectedRange: selectedRange, disabled: !selectedRange || !!editingCell }), _jsx(VerticalSelectButton, { selectedRange: selectedRange, disabled: !selectedRange || !!editingCell }), "|", _jsx(BorderButton, { selectedRange: selectedRange, disabled: !selectedRange || !!editingCell }), _jsx(MergeButton, { selectedRange: selectedRange, disabled: !selectedRange ||
                    isEqual(selectedRange[0], selectedRange[1]) ||
                    !!editingCell }), "|", _jsx(PrintConfigButton, {})] }));
}
export default React.memo(Toolbar);
