import { useCallback, useState } from 'react';
import calcRange from '../reducer/helper/calcCellRange';
export default function usePrintLayout() {
    const [editingCell, setEditingCell] = useState();
    const [selectedRange, setSelectedRange] = useState();
    const [editor, setEditor] = useState();
    const calcCellRange = useCallback((startPos, endPos, merges = []) => {
        setSelectedRange(calcRange(startPos, endPos, merges));
    }, []);
    const [contextMenuShow, setContextMenuShow] = useState(false);
    const [cellRangeForCopyOrCut, setCellRangeForCopyOrCut] = useState();
    const [copyOrCut, setCopyOrCut] = useState();
    return {
        editingCell,
        selectedRange,
        setSelectedRange,
        calcCellRange,
        contextMenuShow,
        setContextMenuShow,
        editor,
        setEditor,
        cellRangeForCopyOrCut,
        setCellRangeForCopyOrCut,
        copyOrCut,
        setCopyOrCut,
        setEditingCell,
    };
}
