import { createStore } from 'redux';
import { PageDirType, PageSizeType } from '@sinoform/types';
import undoableReducer from './undoableReducer';
export const defaultState = {
    cols: {
        len: 20,
    },
    rows: {
        len: 80,
    },
    config: {
        pageConfig: {
            pageDir: PageDirType.VERTICAL,
            pageSize: PageSizeType.A4,
            pagePaddingTop: '25.5',
            pagePaddingBottom: '25.5',
            pagePaddingLeft: '23.7',
            pagePaddingRight: '23.7',
        },
        contentConfig: { isShowDefaultTitle: '0', isAutoHeight: '0' },
    },
};
function buildStore(config) {
    const initialState = {
        present: { ...defaultState, ...config },
        past: [],
        future: [],
    };
    return createStore(undoableReducer, initialState, window.__REDUX_DEVTOOLS_EXTENSION__ &&
        window.__REDUX_DEVTOOLS_EXTENSION__({
            name: '自定义布局',
        }));
}
export default buildStore;
