"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Popper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Popper"));
var _useClickAwayListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/useClickAwayListener"));
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactColor = /*#__PURE__*/require("react-color");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _reducer = /*#__PURE__*/require("../../reducer");
var _getAllSelectedCells = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/getAllSelectedCells"));
var _BgColorIcon = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./BgColorIcon"));
var StyledIconButton = /*#__PURE__*/(0, _styledComponents.default)(_IconButton.default).withConfig({
  displayName: "BgColorPickerBtn__StyledIconButton",
  componentId: "sc-11gtj68-0"
})(["flex-direction:column;border-radius:0;.sinoui-svg-icon{font-size:18px;}"]);
var ColorWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BgColorPickerBtn__ColorWrapper",
  componentId: "sc-11gtj68-1"
})(["background:#fff;box-shadow:0 0 0 1px rgba(0,0,0,0.1);cursor:pointer;width:20px;"]);
var ColorPanel = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BgColorPickerBtn__ColorPanel",
  componentId: "sc-11gtj68-2"
})(["width:100%;height:2px;background:", ";"], function (_ref) {
  var color = _ref.color;
  return color;
});
var PickerPanelWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "BgColorPickerBtn__PickerPanelWrapper",
  componentId: "sc-11gtj68-3"
})(["position:absolute;z-index:2;"]);
/**
 * 填充颜色选择器
 *
 * @param root0
 * @param root0.selectedRange
 * @param root0.disabled
 * @returns
 */
function BgColorPickerButton(_ref2) {
  var selectedRange = _ref2.selectedRange,
    disabled = _ref2.disabled;
  var anchorEl = (0, _react.useRef)(null);
  var popperRef = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = (0, _react.useState)('#F17013'),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    color = _useState4[0],
    setColor = _useState4[1];
  var dispatch = (0, _reactRedux.useDispatch)();
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var handleMouseDown = function handleMouseDown(event) {
    event.preventDefault();
    setOpen(!open);
  };
  var handleClose = function handleClose() {
    setOpen(false);
  };
  var setTextColor = (0, _react.useCallback)(function (selectedColor) {
    if (!selectedRange) {
      return;
    }
    var selectedCells = (0, _getAllSelectedCells.default)(selectedRange, merges);
    dispatch({
      type: _reducer.ActionType.SET_CELLS_STYLE,
      payload: {
        cells: selectedCells,
        style: {
          backgroundColor: selectedColor
        }
      }
    });
  }, [dispatch, merges, selectedRange]);
  var handleChange = function handleChange(colorInfo) {
    setColor(colorInfo.hex);
    setTextColor(colorInfo.hex);
    handleClose();
  };
  (0, _useClickAwayListener.default)([anchorEl, popperRef], handleClose);
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsxs)(StyledIconButton, {
      dense: true,
      ref: anchorEl,
      onMouseDown: handleMouseDown,
      disabled: disabled,
      children: [(0, _jsxRuntime.jsx)(_BgColorIcon.default, {}), (0, _jsxRuntime.jsx)(ColorWrapper, {
        children: (0, _jsxRuntime.jsx)(ColorPanel, {
          color: color
        })
      })]
    }), (0, _jsxRuntime.jsx)(_Popper.default, {
      open: open,
      referenceElement: anchorEl,
      placement: "bottom-start",
      ref: popperRef,
      children: (0, _jsxRuntime.jsx)(PickerPanelWrapper, {
        children: (0, _jsxRuntime.jsx)(_reactColor.SketchPicker, {
          color: color,
          onChange: handleChange
        })
      })
    })]
  });
}
var _default = /*#__PURE__*/_react.default.memo(BgColorPickerButton);
exports.default = _default;