"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Popper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Popper"));
var _useClickAwayListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/useClickAwayListener"));
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _constants = /*#__PURE__*/require("../../constants");
var _setCellTextStyleHelper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/setCellTextStyleHelper"));
var _colorPicker = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../color-picker"));
var _useEventListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../useEventListener"));
var StyledIconButton = /*#__PURE__*/(0, _styledComponents.default)(_IconButton.default).withConfig({
  displayName: "ColorPickerButton__StyledIconButton",
  componentId: "sc-5gkvtl-0"
})(["flex-direction:column;border-radius:0;"]);
var ColorWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ColorPickerButton__ColorWrapper",
  componentId: "sc-5gkvtl-1"
})(["background:#fff;box-shadow:0 0 0 1px rgba(0,0,0,0.1);cursor:pointer;width:20px;"]);
var ColorPanel = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ColorPickerButton__ColorPanel",
  componentId: "sc-5gkvtl-2"
})(["width:100%;height:4px;background:", ";"], function (_ref) {
  var color = _ref.color;
  return color;
});
var PickerPanelWrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ColorPickerButton__PickerPanelWrapper",
  componentId: "sc-5gkvtl-3"
})(["position:absolute;z-index:2;"]);
/**
 * 文本颜色选择器
 *
 * @param root0
 * @param root0.editor
 * @param root0.selectedRange
 * @param root0.editingCell
 * @returns
 */
function ColorPickerButton(_ref2) {
  var _ref2$editor = _ref2.editor,
    editor = _ref2$editor === void 0 ? {} : _ref2$editor,
    selectedRange = _ref2.selectedRange,
    editingCell = _ref2.editingCell;
  var anchorEl = (0, _react.useRef)(null);
  var popperRef = (0, _react.useRef)(null);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = (0, _react.useState)('#F17013'),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    color = _useState4[0],
    setColor = _useState4[1];
  var dispatch = (0, _reactRedux.useDispatch)();
  var rows = (0, _reactRedux.useSelector)(function (state) {
    return state.present.rows;
  });
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var handleMouseDown = function handleMouseDown(event) {
    event.preventDefault();
    setOpen(true);
  };
  (0, _useEventListener.default)(_constants.eventbus, _constants.EDITOR_CHANGE, function () {});
  (0, _useClickAwayListener.default)([anchorEl, popperRef], function () {
    return setOpen(false);
  });
  var handleChange = function handleChange(colorInfo) {
    setColor(colorInfo.hex);
    (0, _setCellTextStyleHelper.default)(editor, dispatch, 'color', colorInfo.hex, rows, merges, selectedRange, editingCell);
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsxs)(StyledIconButton, {
      dense: true,
      ref: anchorEl,
      onMouseDown: handleMouseDown,
      children: [(0, _jsxRuntime.jsx)("div", {
        children: "A"
      }), (0, _jsxRuntime.jsx)(ColorWrapper, {
        children: (0, _jsxRuntime.jsx)(ColorPanel, {
          color: color
        })
      })]
    }), (0, _jsxRuntime.jsx)(_Popper.default, {
      referenceElement: anchorEl,
      open: open,
      placement: "bottom-start",
      ref: popperRef,
      children: (0, _jsxRuntime.jsx)(PickerPanelWrapper, {
        children: (0, _jsxRuntime.jsx)(_colorPicker.default, {
          color: color,
          onChange: handleChange
        })
      })
    })]
  });
}
var _default = /*#__PURE__*/_react.default.memo(ColorPickerButton);
exports.default = _default;