"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _Dialog = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/Dialog"));
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Settings = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/Settings"));
var _rxFormState = /*#__PURE__*/require("@sinoui/rx-form-state");
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _reducer = /*#__PURE__*/require("../../reducer");
var _PrintConfigPanel = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./PrintConfigPanel"));
/**
 * 打印设置按钮
 *
 * @returns
 */
function PrintConfigButton() {
  var anchorEl = (0, _react.useRef)(null);
  var dispatch = (0, _reactRedux.useDispatch)();
  var pageConfig = (0, _reactRedux.useSelector)(function (state) {
    return state.present.config;
  });
  var formState = (0, _rxFormState.useFormState)(pageConfig);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var handleClick = function handleClick() {
    setOpen(true);
  };
  var handleOk = function handleOk() {
    dispatch({
      type: _reducer.ActionType.SET_PRINT_CONFIG,
      payload: formState.values
    });
    setOpen(false);
  };
  var handleClose = function handleClose() {
    setOpen(false);
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)(_IconButton.default, {
      dense: true,
      ref: anchorEl,
      style: {
        borderRadius: 0
      },
      onMouseDown: handleClick,
      children: (0, _jsxRuntime.jsx)(_Settings.default, {})
    }), (0, _jsxRuntime.jsx)(_Dialog.default, {
      open: open,
      children: (0, _jsxRuntime.jsx)(_PrintConfigPanel.default, {
        formState: formState,
        onOk: handleOk,
        onClose: handleClose
      })
    })]
  });
}
var _default = /*#__PURE__*/_react.default.memo(PrintConfigButton);
exports.default = _default;