"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useSingleStyleActive;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _react = /*#__PURE__*/require("react");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _constants = /*#__PURE__*/require("../../constants");
var _isActionHelper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/isActionHelper"));
var _useWatchProp = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/useWatchProp"));
var _useEventListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../useEventListener"));
/**
 * 判断指定样式是否已在选中区域中设置的hook
 *
 * @param style 样式名称
 * @param selectedRange 选中的单元格区域
 * @param isActiveCallback 选中的单元格区域是否有指定样式的回调函数
 * @returns 返回指定样式是否已设置
 */
function useSingleStyleActive(style, selectedRange, isActiveCallback) {
  var state = (0, _reactRedux.useStore)().getState().present;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    isActive = _useState2[0],
    setIsActive = _useState2[1];
  (0, _useWatchProp.default)(selectedRange, function () {
    if (selectedRange) {
      setIsActive((0, _isActionHelper.default)(state, selectedRange, style));
    }
  });
  var handleChange = function handleChange(editor) {
    if (editor) {
      setIsActive(isActiveCallback(editor));
    }
  };
  (0, _useEventListener.default)(_constants.eventbus, _constants.EDITOR_CHANGE, handleChange);
  return [isActive, setIsActive];
}