"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = THead;
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _react = /*#__PURE__*/require("react");
var _classnames = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("classnames"));
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _printOutCore = /*#__PURE__*/require("@sinoform/print-out-core");
var _reducer = /*#__PURE__*/require("../reducer");
var _util = /*#__PURE__*/require("./util");
var _drawRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./drawRange"));
/* eslint-disable no-nested-ternary */
/* eslint-disable jsx-a11y/no-noninteractive-element-interactions */

var MarkLine = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "THead__MarkLine",
  componentId: "sc-112sk15-0"
})(["position:absolute;z-index:2;user-select:none;"]);
function THead(_ref) {
  var selectedRange = _ref.selectedRange;
  var printConfig = (0, _reactRedux.useSelector)(function (state) {
    return state.present;
  });
  var dispatch = (0, _reactRedux.useDispatch)();
  var len = printConfig.cols.len;
  var theadRef = (0, _react.useRef)(null);
  var dragCellIdxRef = (0, _react.useRef)();
  // 拖拽后宽度改变
  var colWidth = (0, _reactRedux.useSelector)(function (state) {
    var cols = state.present.cols;
    var sum = 0;
    for (var i = 0; i < cols.len; i += 1) {
      var _cols$i$width, _cols$i;
      sum += (_cols$i$width = (_cols$i = cols[i]) === null || _cols$i === void 0 ? void 0 : _cols$i.width) !== null && _cols$i$width !== void 0 ? _cols$i$width : _printOutCore.DEFAULT_CELL_WIDTH;
    }
    return sum;
  });
  var verticalMarkLineRef = (0, _react.useRef)(null);
  var markLineOffsetLeft = (0, _react.useMemo)(function () {
    return (0, _util.transformCMToPxByConfig)(printConfig.config, 'v') + 50;
  }, [printConfig.config]);
  var drawMarkLine = (0, _react.useCallback)(function () {
    if (!verticalMarkLineRef.current) return;
    var tds = theadRef.current.querySelectorAll('th');
    var sum = markLineOffsetLeft + tds[0].offsetLeft;
    verticalMarkLineRef.current.style.left = "".concat(sum, "px");
    verticalMarkLineRef.current.style.top = "0px";
    verticalMarkLineRef.current.style.width = '1px';
    verticalMarkLineRef.current.style.height = '100%';
    verticalMarkLineRef.current.style.borderLeft = '1px solid #4b89ff';
  }, [markLineOffsetLeft]);
  (0, _react.useEffect)(function () {
    drawMarkLine();
  }, [drawMarkLine]);
  (0, _react.useEffect)(function () {
    if (selectedRange) {
      (0, _drawRange.default)(selectedRange[0], selectedRange[1]);
    }
  }, [selectedRange, colWidth]);
  var isColInSelectedRange = function isColInSelectedRange(colIdx) {
    if (!selectedRange) return false;
    return selectedRange[0][1] <= colIdx && colIdx <= selectedRange[1][1];
  };
  var handleMouseMoveInDocument = function handleMouseMoveInDocument(event) {
    var rightLine = document.querySelector('.sinoui-drag-right-line');
    if (theadRef.current && rightLine && rightLine.style.display === 'block') {
      var _theadRef$current$get = theadRef.current.getBoundingClientRect(),
        left = _theadRef$current$get.left;
      rightLine.style.left = "".concat(event.clientX - left, "px");
    }
  };
  var handleMouseUpInDocument = function handleMouseUpInDocument(event) {
    var leftLine = document.querySelector('.sinoui-drag-left-line');
    var rightLine = document.querySelector('.sinoui-drag-right-line');
    if (theadRef.current && dragCellIdxRef.current && leftLine && leftLine.style.display === 'block' && rightLine && rightLine.style.display === 'block') {
      leftLine.style.display = 'none';
      rightLine.style.display = 'none';
      var _theadRef$current$get2 = theadRef.current.getBoundingClientRect(),
        left = _theadRef$current$get2.left;
      var dragCell = theadRef.current.querySelectorAll('th')[dragCellIdxRef.current];
      var width = event.clientX - dragCell.offsetLeft - left > 0 ? event.clientX - dragCell.offsetLeft - left >= 10 ? event.clientX - dragCell.offsetLeft - left : 10 : 10;
      dispatch((0, _reducer.changeColWidth)(dragCellIdxRef.current - 1, width));
    }
    document.removeEventListener('mousemove', handleMouseMoveInDocument, false);
    document.removeEventListener('mouseup', handleMouseUpInDocument, false);
  };
  var handleMouseMoveInThead = function handleMouseMoveInThead(event) {
    var cell = event.target;
    var _theadRef$current$get3 = theadRef.current.getBoundingClientRect(),
      left = _theadRef$current$get3.left;
    // 如果当前鼠标位置大于单元格宽段-5 且当前鼠标放在表头
    if (event.clientX - left >= cell.offsetWidth + cell.offsetLeft - 5 && cell.tagName === 'TH' && cell.cellIndex !== 0) {
      // 设置鼠标样式
      cell.style.cursor = 'col-resize';
    } else {
      cell.style.cursor = 'default';
    }
  };
  var handleMouseDown = function handleMouseDown(event) {
    var cell = event.target;
    var _theadRef$current$get4 = theadRef.current.getBoundingClientRect(),
      left = _theadRef$current$get4.left;
    var leftLine = document.querySelector('.sinoui-drag-left-line');
    var rightLine = document.querySelector('.sinoui-drag-right-line');
    if (event.clientX - left >= cell.offsetWidth + cell.offsetLeft - 5 && cell.tagName === 'TH' && cell.cellIndex !== 0) {
      // 处理拖拽改变列宽
      dragCellIdxRef.current = cell.cellIndex;
      // 显示辅助线
      if (leftLine && leftLine.style.display !== 'block') {
        leftLine.style.display = 'block';
        leftLine.style.left = "".concat(cell.offsetLeft, "px");
      }
      if (rightLine && rightLine.style.display !== 'block') {
        rightLine.style.display = 'block';
        rightLine.style.left = "".concat(cell.offsetLeft + cell.clientWidth, "px");
      }
      document.addEventListener('mousemove', handleMouseMoveInDocument, false);
      document.addEventListener('mouseup', handleMouseUpInDocument, false);
    }
    // else {
    //   // 处理选中整列
    //   const colId = parseInt(cell.dataset?.colid!, 10);
    //   drawRange([0, colId], [printConfig.rows.len - 1, colId]);
    //   selectStartCellRef.current = colId;
    //   document.addEventListener('mousemove', handleMouseMoveForSelect, false);
    //   document.addEventListener('mouseup', handleMouseUpForSelect, false);
    // }
  };

  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)("thead", {
      ref: theadRef,
      className: "custom-print-table-row-header",
      onMouseMove: handleMouseMoveInThead,
      onMouseDown: handleMouseDown,
      children: (0, _jsxRuntime.jsxs)("tr", {
        children: [(0, _jsxRuntime.jsx)("th", {
          children: (0, _jsxRuntime.jsx)("div", {})
        }), Array.from({
          length: len
        }).map(function (_item, idx) {
          var str = String.fromCharCode(idx + 65);
          return (0, _jsxRuntime.jsx)("th", {
            className: (0, _classnames.default)({
              'col-in-selected-range': isColInSelectedRange(idx)
            }),
            id: "table-col-header-".concat(idx),
            "data-colid": idx,
            children: str
          }, idx);
        })]
      })
    }), (0, _jsxRuntime.jsx)(MarkLine, {
      ref: verticalMarkLineRef,
      "data-markline": true
    })]
  });
}