"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = TBody;
var _objectSpread2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectWithoutProperties"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _react = /*#__PURE__*/require("react");
var _classnames = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("classnames"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _printOutCore = /*#__PURE__*/require("@sinoform/print-out-core");
var _reducer = /*#__PURE__*/require("../reducer");
var _Td = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./Td"));
var _util = /*#__PURE__*/require("./util");
var _constants = /*#__PURE__*/require("../constants");
var _drawRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./drawRange"));
var _excluded = ["border"];
var MarkLine = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "TBody__MarkLine",
  componentId: "sc-11w4iis-0"
})(["position:absolute;user-select:none;"]);
var SelectRange = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "TBody__SelectRange",
  componentId: "sc-11w4iis-1"
})(["position:absolute;display:none;border:2px solid #4b89ff;user-select:none;pointer-events:none;box-sizing:border-box;"]);
function TBody(_ref) {
  var selectedRange = _ref.selectedRange,
    setEditor = _ref.setEditor,
    handleTdDoubleClick = _ref.handleTdDoubleClick,
    fields = _ref.fields;
  var printConfig = (0, _reactRedux.useSelector)(function (state) {
    return state.present;
  });
  var rowHeight = (0, _reactRedux.useSelector)(function (state) {
    var rows = state.present.rows;
    var sum = 0;
    for (var i = 0; i < rows.len; i += 1) {
      var _rows$i$height, _rows$i;
      sum += (_rows$i$height = (_rows$i = rows[i]) === null || _rows$i === void 0 ? void 0 : _rows$i.height) !== null && _rows$i$height !== void 0 ? _rows$i$height : _printOutCore.DEFAULT_CELL_HEIGHT;
    }
    return sum;
  });
  var colLenArray = Array.from({
    length: printConfig.cols.len
  });
  var rowLenArray = Array.from({
    length: printConfig.rows.len
  });
  var dragTrIdxRef = (0, _react.useRef)();
  var tBodyRef = (0, _react.useRef)(null);
  var horizontalMarkLineRef = (0, _react.useRef)(null);
  var markLineOffsetTop = (0, _react.useMemo)(function () {
    return (0, _util.transformCMToPxByConfig)(printConfig.config, 'h');
  }, [printConfig.config]);
  var drawMarkLine = (0, _react.useCallback)(function () {
    if (!horizontalMarkLineRef.current) return;
    var trs = tBodyRef.current.querySelectorAll('tr');
    var sum = 0;
    for (var i = 0; i < trs.length; i += 1) {
      if (trs[i].offsetTop + trs[i].offsetHeight <= markLineOffsetTop) {
        sum = trs[i].offsetTop + trs[i].offsetHeight;
      } else {
        break;
      }
    }
    horizontalMarkLineRef.current.style.top = "".concat(sum, "px");
    horizontalMarkLineRef.current.style.left = "0px";
    horizontalMarkLineRef.current.style.width = '100%';
    horizontalMarkLineRef.current.style.height = '1px';
    horizontalMarkLineRef.current.style.borderTop = '1px solid #4b89ff';
  }, [markLineOffsetTop]);
  (0, _react.useEffect)(function () {
    drawMarkLine();
  }, [drawMarkLine]);
  (0, _react.useEffect)(function () {
    if (selectedRange) {
      (0, _drawRange.default)(selectedRange[0], selectedRange[1]);
    }
  }, [selectedRange, rowHeight]);
  var dispatch = (0, _reactRedux.useDispatch)();
  var isRowInSelectedRange = function isRowInSelectedRange(rowIdx) {
    if (!selectedRange) return false;
    return selectedRange[0][0] <= rowIdx && rowIdx <= selectedRange[1][0];
  };
  var handleMouseMoveInDocument = function handleMouseMoveInDocument(event) {
    var bottomLine = document.querySelector('.sinoui-drag-bottom-line');
    var theadElement = document.querySelector('thead');
    var _theadElement$getBoun = theadElement.getBoundingClientRect(),
      top = _theadElement$getBoun.top;
    if (bottomLine && bottomLine.style.display === 'block') {
      bottomLine.style.top = "".concat(event.clientY - top, "px");
    }
  };
  var handleMouseUpInDocument = function handleMouseUpInDocument(event) {
    var topLine = document.querySelector('.sinoui-drag-top-line');
    var bottomLine = document.querySelector('.sinoui-drag-bottom-line');
    if (dragTrIdxRef.current && topLine && topLine.style.display === 'block' && bottomLine && bottomLine.style.display === 'block') {
      topLine.style.display = 'none';
      bottomLine.style.display = 'none';
      var theadElement = document.querySelector('thead');
      var _theadElement$getBoun2 = theadElement.getBoundingClientRect(),
        top = _theadElement$getBoun2.top;
      var dragCell = document.querySelectorAll('tr')[dragTrIdxRef.current];
      var height = event.clientY - dragCell.offsetTop - top > 0 ? event.clientY - dragCell.offsetTop - top >= _constants.MIN_CELL_HEIGHT ? event.clientY - dragCell.offsetTop - top : _constants.MIN_CELL_HEIGHT : _constants.MIN_CELL_HEIGHT;
      dispatch((0, _reducer.changeRowHeight)(dragTrIdxRef.current - 1, height));
    }
    document.removeEventListener('mousemove', handleMouseMoveInDocument, false);
    document.removeEventListener('mouseup', handleMouseUpInDocument, false);
  };
  var handleMouseMoveInFirstCol = function handleMouseMoveInFirstCol(event) {
    var cell = event.target;
    var theadElement = document.querySelector('thead');
    var _theadElement$getBoun3 = theadElement.getBoundingClientRect(),
      top = _theadElement$getBoun3.top;
    if (event.clientY - top >= cell.offsetHeight + cell.offsetTop - 10 && cell.tagName === 'TD' && cell.cellIndex === 0) {
      // 设置鼠标样式
      cell.style.cursor = 'row-resize';
    } else {
      cell.style.cursor = 'default';
    }
  };
  var handleMouseDownInFirstCol = function handleMouseDownInFirstCol(event) {
    var cell = event.target;
    var theadElement = document.querySelector('thead');
    var _theadElement$getBoun4 = theadElement.getBoundingClientRect(),
      top = _theadElement$getBoun4.top;
    var topLine = document.querySelector('.sinoui-drag-top-line');
    var bottomLine = document.querySelector('.sinoui-drag-bottom-line');
    if (event.clientY - top >= cell.offsetHeight + cell.offsetTop - 10 && cell.tagName === 'TD' && cell.cellIndex === 0) {
      dragTrIdxRef.current = event.currentTarget.rowIndex;
      // 显示辅助线
      if (topLine && topLine.style.display !== 'block') {
        topLine.style.display = 'block';
        topLine.style.top = "".concat(cell.offsetTop, "px");
      }
      if (bottomLine && bottomLine.style.display !== 'block') {
        bottomLine.style.display = 'block';
        bottomLine.style.top = "".concat(cell.offsetTop + cell.offsetHeight, "px");
      }
      document.addEventListener('mousemove', handleMouseMoveInDocument, false);
      document.addEventListener('mouseup', handleMouseUpInDocument, false);
    }
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)("tbody", {
      ref: tBodyRef,
      children: rowLenArray.map(function (_, rowIdx) {
        var _row$height;
        var row = printConfig.rows[rowIdx];
        var cells = row === null || row === void 0 ? void 0 : row.cells;
        return (0, _jsxRuntime.jsxs)("tr", {
          style: {
            height: "".concat((_row$height = row === null || row === void 0 ? void 0 : row.height) !== null && _row$height !== void 0 ? _row$height : _printOutCore.DEFAULT_CELL_HEIGHT, "px")
          },
          onMouseMove: handleMouseMoveInFirstCol,
          onMouseDown: handleMouseDownInFirstCol,
          children: [(0, _jsxRuntime.jsx)("td", {
            className: (0, _classnames.default)('custom-print-table-col-header', {
              'row-in-selected-range': isRowInSelectedRange(rowIdx)
            }),
            id: "table-row-header-".concat(rowIdx),
            "data-rowid": rowIdx,
            children: rowIdx + 1
          }), colLenArray.map(function (_item, colIdx) {
            var _cell$style;
            var cell = cells === null || cells === void 0 ? void 0 : cells[colIdx];
            if ((0, _util.checkTdIsMerged)(rowIdx, colIdx, printConfig.merges)) {
              return null;
            }
            var _ref2 = (_cell$style = cell === null || cell === void 0 ? void 0 : cell.style) !== null && _cell$style !== void 0 ? _cell$style : {},
              border = _ref2.border,
              style = (0, _objectWithoutProperties2.default)(_ref2, _excluded);
            return (0, _jsxRuntime.jsx)(_Td.default, {
              cell: cell,
              colIdx: colIdx,
              rowIdx: rowIdx,
              handleTdDoubleClick: handleTdDoubleClick,
              setEditor: setEditor,
              height: (0, _util.getCellHeight)(printConfig, rowIdx, cell),
              width: (0, _util.getCellWidth)(printConfig, colIdx, cell),
              fields: fields,
              style: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, style), (0, _util.getCellBorderStyle)(border))
            }, "".concat(rowIdx, "-").concat(colIdx));
          })]
        }, rowIdx);
      })
    }), (0, _jsxRuntime.jsx)(MarkLine, {
      ref: horizontalMarkLineRef,
      "data-markline": true
    }), (0, _jsxRuntime.jsx)(SelectRange, {
      className: "sinoui-table-select-range"
    })]
  });
}