"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectSpread2"));
var _toConsumableArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/toConsumableArray"));
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
require("prismjs/themes/prism.css");
require("./index.css");
var _globalUi = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoform/global-ui"));
var _useEventCallback = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/utils/useEventCallback"));
var _closest = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("dom-helpers/closest"));
var _contains = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("dom-helpers/contains"));
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _slate = /*#__PURE__*/require("slate");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _slateEditor = /*#__PURE__*/require("../components/slate-editor");
var _constants = /*#__PURE__*/require("../constants");
var _reducer = /*#__PURE__*/require("../reducer");
var _calcCellRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../reducer/helper/calcCellRange"));
var _checkCellMergedInRow = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../reducer/helper/checkCellMergedInRow"));
var _getTableWidth = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../utils/getTableWidth"));
var _isInCode = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../utils/isInCode"));
var _validateSubForm = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../utils/validateSubForm"));
var _ColGroup = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./ColGroup"));
var _ContextMenu = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./ContextMenu"));
var _drawRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./drawRange"));
var _TBody = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./TBody"));
var _THead = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./THead"));
var _usePrintLayout2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./usePrintLayout"));
/* eslint-disable react/display-name */
/* eslint-disable @typescript-eslint/no-non-null-assertion */
/* eslint-disable react-hooks/exhaustive-deps */

var Layout = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "Table__Layout",
  componentId: "sc-1rs5tn2-0"
})(["position:relative;width:100%;height:100%;overflow:hidden;font-size:16px;"]);
var TableContainer = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "Table__TableContainer",
  componentId: "sc-1rs5tn2-1"
})(["height:calc(100% - 40px);overflow:scroll;position:relative;"]);
var Line = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "Table__Line",
  componentId: "sc-1rs5tn2-2"
})(["position:absolute;top:0;bottom:0;height:", ";display:none;width:", ";z-index:9999;border-left:", ";border-top:", ";cursor:", ";"], function (_ref) {
  var isHorizontal = _ref.isHorizontal;
  return isHorizontal ? '2px' : '100%';
}, function (_ref2) {
  var isHorizontal = _ref2.isHorizontal;
  return isHorizontal ? '100%' : '2px';
}, function (_ref3) {
  var isHorizontal = _ref3.isHorizontal;
  return isHorizontal ? 'none' : '1px dotted #000';
}, function (_ref4) {
  var isHorizontal = _ref4.isHorizontal;
  return isHorizontal ? '1px dotted #000' : 'none';
}, function (_ref5) {
  var isHorizontal = _ref5.isHorizontal;
  return isHorizontal ? 'row-resize' : 'col-resize';
});
function InnerTable(_ref6) {
  var fields = _ref6.fields;
  var tableRef = (0, _react.useRef)(null);
  var _usePrintLayout = (0, _usePrintLayout2.default)(),
    calcCellRange = _usePrintLayout.calcCellRange,
    selectedRange = _usePrintLayout.selectedRange,
    setSelectedRange = _usePrintLayout.setSelectedRange,
    setContextMenuShow = _usePrintLayout.setContextMenuShow,
    contextMenuShow = _usePrintLayout.contextMenuShow,
    copyOrCut = _usePrintLayout.copyOrCut,
    setCopyOrCut = _usePrintLayout.setCopyOrCut,
    editor = _usePrintLayout.editor,
    cellRangeForCopyOrCut = _usePrintLayout.cellRangeForCopyOrCut,
    setCellRangeForCopyOrCut = _usePrintLayout.setCellRangeForCopyOrCut,
    setEditor = _usePrintLayout.setEditor,
    setEditingCell = _usePrintLayout.setEditingCell;
  var editingCell = (0, _reactRedux.useSelector)(function (state) {
    return state.present.editingCell;
  });
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var rows = (0, _reactRedux.useSelector)(function (state) {
    return state.present.rows;
  });
  var cols = (0, _reactRedux.useSelector)(function (state) {
    return state.present.cols;
  });
  var state = (0, _reactRedux.useStore)().getState().present;
  var dispatch = (0, _reactRedux.useDispatch)();
  var _useState = (0, _react.useState)(),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    pos = _useState2[0],
    setPos = _useState2[1];
  var windowRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    windowRef.current = document.querySelector('.sinoui-dialog');
  }, []);
  var handleContextMenu = (0, _react.useCallback)(function (event) {
    event.preventDefault();
    if (editingCell) {
      return;
    }
    var clickX = event.clientX;
    var clickY = event.clientY;
    var screenW = window.innerWidth;
    var screenH = window.innerHeight;
    var left = clickX;
    var top = clickY;
    if (clickX + _constants.DEFAULT_MENU_WIDTH >= screenW) {
      left = clickX - _constants.DEFAULT_MENU_WIDTH;
    }
    if (clickY + _constants.DEFAULT_MENU_HEIGHT >= screenH) {
      top = clickY - _constants.DEFAULT_MENU_HEIGHT;
    }
    setContextMenuShow(true);
    setPos([left, top]);
  }, [setContextMenuShow, editingCell]);
  var changeCellValue = (0, _useEventCallback.default)(function () {
    var _ref7 = editingCell !== null && editingCell !== void 0 ? editingCell : [-1, -1],
      _ref8 = (0, _slicedToArray2.default)(_ref7, 2),
      rowIdx = _ref8[0],
      colIdx = _ref8[1];
    var isValid = (0, _validateSubForm.default)(state, rowIdx, colIdx, editor === null || editor === void 0 ? void 0 : editor.children, editor, fields);
    if (isValid) {
      dispatch({
        type: _reducer.ActionType.EDIT_CELL_VALUE,
        payload: {
          cellPos: [rowIdx, colIdx],
          value: editor === null || editor === void 0 ? void 0 : editor.children
        }
      });
    }
    dispatch({
      type: _reducer.ActionType.SET_EDITING_CELL,
      payload: undefined
    });
    if (editor) _slate.Transforms.setSelection(editor, {
      anchor: {
        path: [0, 0],
        offset: 0
      },
      focus: {
        path: [0, 0],
        offset: 0
      }
    });
    setEditor(undefined);
  });
  /**
   * 全局点击事件的处理
   *
   * @param event
   */
  var handleClick = (0, _useEventCallback.default)(function (event) {
    var enableElement = document.querySelector('.sino-custom-print-layout');
    var targetElement = event.target;
    if (enableElement && !(0, _contains.default)(enableElement, targetElement)) {
      var _windowRef$current;
      changeCellValue();
      (_windowRef$current = windowRef.current) === null || _windowRef$current === void 0 ? void 0 : _windowRef$current.removeEventListener('click', handleClick, false);
    }
  });
  (0, _react.useEffect)(function () {
    var _tableRef$current;
    (_tableRef$current = tableRef.current) === null || _tableRef$current === void 0 ? void 0 : _tableRef$current.addEventListener('contextmenu', handleContextMenu);
    return function () {
      var _tableRef$current2;
      (_tableRef$current2 = tableRef.current) === null || _tableRef$current2 === void 0 ? void 0 : _tableRef$current2.removeEventListener('contextmenu', handleContextMenu);
    };
  }, [handleContextMenu]);
  var mouseMoveFnRef = (0, _react.useRef)(null);
  var mouseUpFnRef = (0, _react.useRef)(null);
  var hoverRowIdx = (0, _react.useRef)();
  var hoverColIdx = (0, _react.useRef)();
  /**
   * 鼠标滑动事件
   *
   * @param startPos 单元格位置
   */
  var handleMouseMove = function handleMouseMove(startPos) {
    return function (event) {
      var _event$target, _event$target$dataset, _target$dataset, _target$dataset2;
      // 判断是否是页面的标识线，如果是标识线跳过事件处理方法
      if ((_event$target = event.target) !== null && _event$target !== void 0 && (_event$target$dataset = _event$target.dataset) !== null && _event$target$dataset !== void 0 && _event$target$dataset.markline) {
        return;
      }
      var target = (0, _closest.default)(event.target, 'td');
      if (!target || !((_target$dataset = target.dataset) !== null && _target$dataset !== void 0 && _target$dataset.rowid) || !((_target$dataset2 = target.dataset) !== null && _target$dataset2 !== void 0 && _target$dataset2.colid)) {
        var _range = (0, _calcCellRange.default)(startPos, [hoverRowIdx.current, hoverColIdx.current], merges);
        setSelectedRange(_range);
        document.removeEventListener('mousemove', mouseMoveFnRef.current);
        document.removeEventListener('mouseup', mouseUpFnRef.current);
        hoverRowIdx.current = undefined;
        hoverColIdx.current = undefined;
        mouseMoveFnRef.current = null;
        mouseUpFnRef.current = null;
        return;
      }
      var rowIdx = target.dataset.rowid ? parseInt(target.dataset.rowid, 10) : hoverRowIdx.current;
      var colIdx = target.dataset.colid ? parseInt(target.dataset.colid, 10) : hoverColIdx.current;
      var range = (0, _calcCellRange.default)(startPos, [rowIdx, colIdx], merges);
      hoverRowIdx.current = rowIdx;
      hoverColIdx.current = colIdx;
      (0, _drawRange.default)(range[0], range[1]);
    };
  };
  /**
   * 鼠标按起事件
   *
   * @param startPos  单元格位置
   */
  var handleMouseUp = function handleMouseUp(startPos) {
    return function (event) {
      var _target$dataset3, _target$dataset4;
      var target = (0, _closest.default)(event.target, 'td');
      if (!target || !((_target$dataset3 = target.dataset) !== null && _target$dataset3 !== void 0 && _target$dataset3.rowid) || !((_target$dataset4 = target.dataset) !== null && _target$dataset4 !== void 0 && _target$dataset4.colid)) {
        return;
      }
      var rowIdx = parseInt(target.dataset.rowid, 10);
      var colIdx = parseInt(target.dataset.colid, 10);
      calcCellRange(startPos, [rowIdx, colIdx], merges);
      document.removeEventListener('mousemove', mouseMoveFnRef.current);
      document.removeEventListener('mouseup', mouseUpFnRef.current);
      mouseMoveFnRef.current = null;
      mouseUpFnRef.current = null;
    };
  };
  /**
   * 鼠标按下事件
   *
   * @param event  event
   */
  var handleMouseDown = function handleMouseDown(event) {
    var _target$dataset5, _target$dataset6, _target$dataset$merge;
    var target = (0, _closest.default)(event.target, 'td');
    if (!target || !((_target$dataset5 = target.dataset) !== null && _target$dataset5 !== void 0 && _target$dataset5.rowid) || !((_target$dataset6 = target.dataset) !== null && _target$dataset6 !== void 0 && _target$dataset6.colid)) {
      return;
    }
    var rowIdx = parseInt(target.dataset.rowid, 10);
    var colIdx = parseInt(target.dataset.colid, 10);
    var merge = JSON.parse((_target$dataset$merge = target.dataset.merge) !== null && _target$dataset$merge !== void 0 ? _target$dataset$merge : '');
    hoverRowIdx.current = rowIdx;
    hoverColIdx.current = colIdx;
    if (editingCell && editingCell[0] === rowIdx && editingCell[1] === colIdx) {
      return;
    }
    changeCellValue();
    if (event.buttons !== 2) {
      setContextMenuShow(false);
    } else if (selectedRange && rowIdx >= selectedRange[0][0] && rowIdx <= selectedRange[1][0] && colIdx >= selectedRange[0][1] && colIdx <= selectedRange[1][1]) {
      // 右键
      // 判断是否在当前选中区域内，如果在当前区域内不做操作，显示右键菜单
      return;
    }
    var endPos = [rowIdx + merge[0], colIdx + merge[1]];
    setSelectedRange([[rowIdx, colIdx], endPos]);
    setEditingCell(undefined);
    (0, _drawRange.default)([rowIdx, colIdx], [rowIdx, colIdx]);
    mouseMoveFnRef.current = handleMouseMove([rowIdx, colIdx]);
    mouseUpFnRef.current = handleMouseUp([rowIdx, colIdx]);
    document.addEventListener('mousemove', mouseMoveFnRef.current);
    document.addEventListener('mouseup', mouseUpFnRef.current);
  };
  var handleTdDrop = function handleTdDrop(event) {
    var _target$dataset7, _target$dataset8;
    var target = (0, _closest.default)(event.target, 'td');
    var field = event.dataTransfer.getData('field');
    if (!target || !((_target$dataset7 = target.dataset) !== null && _target$dataset7 !== void 0 && _target$dataset7.rowid) || !((_target$dataset8 = target.dataset) !== null && _target$dataset8 !== void 0 && _target$dataset8.colid) || !field) {
      return;
    }
    field = JSON.parse(field);
    var rowIdx = parseInt(target.dataset.rowid, 10);
    var colIdx = parseInt(target.dataset.colid, 10);
    if (field.parent && (0, _checkCellMergedInRow.default)(rowIdx, merges)) {
      _globalUi.default.message.error('子表单项所在行存在合并单元格的合并行超出当前行');
      return;
    }
    if (editingCell && editingCell[0] === rowIdx && editingCell[1] === colIdx) {
      // 当前单元格处于编辑状态
      var _editor$selection = editor.selection,
        anchor = _editor$selection.anchor,
        focus = _editor$selection.focus,
        insertText = editor.insertText;
      if (_slate.Point.equals(anchor, focus)) {
        var _editor$children;
        // 同行不能出现不同子表单的表单项
        if ((0, _reducer.checkSubFieldInRow)(state, [rowIdx, colIdx], [].concat((0, _toConsumableArray2.default)((_editor$children = editor === null || editor === void 0 ? void 0 : editor.children) !== null && _editor$children !== void 0 ? _editor$children : []), [{
          type: 'paragraph',
          children: [{
            text: "${".concat(field.valueExp, "}")
          }]
        }]), fields)) {
          _globalUi.default.message.error('同一行单元格的表达式中不能出现不同子表单的表单项');
          return;
        }
        // 判断当前光标是否在表达式内部，如果在表达式内直接插入表单项id，否则需要将表单项id包装成表达式的格式
        var checkIsInCode = (0, _isInCode.default)(editor, focus);
        var insertString = checkIsInCode ? "".concat(field.valueExp) : "${".concat(field.valueExp, "}");
        insertText(insertString);
        var selectRange = {
          anchor: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, anchor), {}, {
            offset: anchor.offset + insertString.length
          }),
          focus: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, focus), {}, {
            offset: focus.offset + insertString.length
          })
        };
        _slate.Transforms.setSelection(editor, selectRange);
      }
      dispatch({
        type: _reducer.ActionType.EDIT_CELL_VALUE,
        payload: {
          cellPos: [rowIdx, colIdx],
          value: editor === null || editor === void 0 ? void 0 : editor.children,
          fields: fields
        }
      });
    } else {
      var _rows$rowIdx$cells$co, _rows$rowIdx, _rows$rowIdx$cells, _rows$rowIdx$cells$co2;
      // 在当前单元格的最后追加表单项字符串
      var cellValue = (_rows$rowIdx$cells$co = rows === null || rows === void 0 ? void 0 : (_rows$rowIdx = rows[rowIdx]) === null || _rows$rowIdx === void 0 ? void 0 : (_rows$rowIdx$cells = _rows$rowIdx.cells) === null || _rows$rowIdx$cells === void 0 ? void 0 : (_rows$rowIdx$cells$co2 = _rows$rowIdx$cells[colIdx]) === null || _rows$rowIdx$cells$co2 === void 0 ? void 0 : _rows$rowIdx$cells$co2.value) !== null && _rows$rowIdx$cells$co !== void 0 ? _rows$rowIdx$cells$co : [];
      var newValue = [].concat((0, _toConsumableArray2.default)(cellValue), [{
        type: 'paragraph',
        children: [{
          text: "${".concat(field.valueExp, "}")
        }]
      }]);
      if ((0, _reducer.checkSubFieldInRow)(state, [rowIdx, colIdx], newValue, fields)) {
        _globalUi.default.message.error('同一行单元格的表达式中不能出现不同子表单的表单项');
        return;
      }
      dispatch({
        type: _reducer.ActionType.EDIT_CELL_VALUE,
        payload: {
          cellPos: [rowIdx, colIdx],
          value: newValue,
          fields: fields
        }
      });
    }
  };
  /**
   * 鼠标拖拽悬浮事件
   *
   * @param event  event
   */
  var handleTdDragOver = function handleTdDragOver(event) {
    var _target$dataset9, _target$dataset10;
    var target = (0, _closest.default)(event.target, 'td');
    if (target !== null && target !== void 0 && (_target$dataset9 = target.dataset) !== null && _target$dataset9 !== void 0 && _target$dataset9.rowid && (_target$dataset10 = target.dataset) !== null && _target$dataset10 !== void 0 && _target$dataset10.colid) {
      event.preventDefault();
    }
  };
  var handleKeyDown = (0, _useEventCallback.default)(function (event) {
    if (event.key === 'Escape') {
      changeCellValue();
      document.removeEventListener('keydown', handleKeyDown, false);
    }
  });
  var handleTdDoubleClick = (0, _useEventCallback.default)(function () {
    var _windowRef$current2;
    setCellRangeForCopyOrCut(undefined);
    document.addEventListener('keydown', handleKeyDown, false);
    (_windowRef$current2 = windowRef.current) === null || _windowRef$current2 === void 0 ? void 0 : _windowRef$current2.addEventListener('click', handleClick, false);
  });
  var style = {
    width: (0, _getTableWidth.default)(cols)
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)(_slateEditor.Toolbar, {
      editor: editor,
      selectedRange: selectedRange,
      editingCell: editingCell
    }), (0, _jsxRuntime.jsxs)(TableContainer, {
      children: [(0, _jsxRuntime.jsxs)("table", {
        className: "custom-print-table",
        ref: tableRef,
        onDrop: handleTdDrop,
        onDragOver: handleTdDragOver,
        onMouseDown: handleMouseDown,
        cellPadding: 0,
        style: style,
        children: [(0, _jsxRuntime.jsx)(_ColGroup.default, {}), (0, _jsxRuntime.jsx)(_THead.default, {
          selectedRange: selectedRange
        }), (0, _jsxRuntime.jsx)(_TBody.default, {
          selectedRange: selectedRange,
          handleTdDoubleClick: handleTdDoubleClick,
          setEditor: setEditor,
          fields: fields
        })]
      }), (0, _jsxRuntime.jsx)(Line, {
        className: "sinoui-drag-left-line"
      }), (0, _jsxRuntime.jsx)(Line, {
        className: "sinoui-drag-right-line"
      }), (0, _jsxRuntime.jsx)(Line, {
        isHorizontal: true,
        className: "sinoui-drag-top-line"
      }), (0, _jsxRuntime.jsx)(Line, {
        isHorizontal: true,
        className: "sinoui-drag-bottom-line"
      })]
    }), (0, _jsxRuntime.jsx)(_ContextMenu.default, {
      pos: pos,
      contextMenuShow: contextMenuShow,
      setContextMenuShow: setContextMenuShow,
      selectedRange: selectedRange,
      copyOrCut: copyOrCut,
      setCopyOrCut: setCopyOrCut,
      cellRangeForCopyOrCut: cellRangeForCopyOrCut,
      setCellRangeForCopyOrCut: setCellRangeForCopyOrCut,
      setSelectedRange: setSelectedRange
    })]
  });
}
var Table = /*#__PURE__*/_react.default.forwardRef(function (_ref9, ref) {
  var config = _ref9.config,
    fieldItems = _ref9.fieldItems;
  var store = (0, _react.useMemo)(function () {
    return (0, _reducer.buildStore)(config);
  }, [config]);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getCurrentConfig: function getCurrentConfig() {
        return store.getState().present;
      },
      replaceConfig: function replaceConfig(value) {
        return store.dispatch({
          type: _reducer.ActionType.REPLACE_CONFIG,
          payload: value
        });
      }
    };
  });
  return (0, _jsxRuntime.jsx)(_reactRedux.Provider, {
    store: store,
    children: (0, _jsxRuntime.jsx)(Layout, {
      children: (0, _jsxRuntime.jsx)(InnerTable, {
        fields: fieldItems
      })
    })
  });
});
var _default = Table;
exports.default = _default;