"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getAllSelectedCells;
var _lodashEs = /*#__PURE__*/require("lodash-es");
var _getAllCellsInRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./getAllCellsInRange"));
var _getAllInMergedCells = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./getAllInMergedCells"));
/**
 * 获取选中范围内所有单元格
 * @param selectedRange 选中范围
 * @returns
 */
function getAllSelectedCells(selectedRange) {
  var merges = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var cellsInRange = (0, _getAllCellsInRange.default)(selectedRange);
  var cellsInMerge = (0, _getAllInMergedCells.default)(merges);
  return cellsInRange.filter(function (cell) {
    return cellsInMerge.findIndex(function (item) {
      return (0, _lodashEs.isEqual)(item, cell);
    }) === -1;
  });
}